## Part 1
## 1.2 Rɂ郂_ȃf[^O̊b
## 
## Tvf[^т̍쐬ɗpR[h
## https://github.com/ymattu/manatee_book_files
## ŌJĂ܂

# 049P

# @ 1
library(readr)
dat <- read_csv("hoge.csv")

# @ 2
dat <- readr::read_csv("hoge.csv")

# 050P
# pbP[WCXg[ĂȂꍇ install.packages("pbP[W")ŃCXg[
library(readr)
library(readxl)
library(dplyr)
library(lubridate)
library(knitr) # ʂ̏o͂̂

dat <- read.csv("product.csv")
dat <- read.delim("product.tsv")

kable(head(dat)) # 擪 6 so

# 051P
str(dat)

dat <- read.csv("product.csv", stringsAsFactors = FALSE)
dat <- read.delim("product.tsv", stringsAsFactors = FALSE)

str(dat)

dat <- read_csv("product.csv")
dat <- read_tsv("product.tsv")

str(dat)

# 052P
system.time(dat <- read.csv("product.csv"))

system.time(dat <- readr::read_csv("product.csv"))


# 053P
# R ̕W֐̏ꍇ
dat.sji <- read.csv("hoge.csv", stringAsFactors = FALSE, fileEncoding = "cp932")

# readr pbP[W̏ꍇ
dat_sjis <- readr::read_csv("hoge.csv", locale = locale(encoding = "cp932"))

datxl <- readxl::read_excel("product.xlsx", sheet = 1)
str(datxl)

# 054P
dat <- read_csv("product.csv")

dat_nameprice <- dat[, c(1, 2, 3)] # ԍw
kable(head(dat_nameprice))

dat_nameprice <- select(dat, ProductID, ProductName, Price)

# 055P
select(dat, 1, 2, 3) # ԍw
select(dat, 1:3) # ԍAĂꍇ
select(dat, ProductID:Price) # 񖼂łAĂΓl
select(dat, -Date) # ̗
select(dat, -4) # ̗ԍ
select(dat, starts_with("P")) # "P"Ŏn܂񖼂̂ݑI
select(dat, starts_with("p"), ignore.case = TRUE) # 啶𖳎
select(dat, contains("Pr")) # "Pr"񖼂Ɋ܂ނ̂̂ݑI
select(dat, matches("^(Pro|Pri)")) # "Pro"܂"Pri"Ŏn܂I

dat_5000 <- subset(dat, Price >= 5000)
kable(head(dat_5000))

dat_5000 <- filter(dat, Price >= 5000)

# 056P
dat$Year <- lubridate::year(dat$Date)
kable(head(dat))

dat_year <- mutate(dat, Year = lubridate::year(Date))

# 057P
dat_year_order <- dat_year[order(dat_year$Date), ] # 
kable(head(dat_year_order))

dat_year_desc <- dat_year[order(dat_year$Date, decreasing = T), ] # 
kable(head(dat_year_desc))

dat_year_order <- arrange(dat_year, Date) # 
dat_year_desc <- arrange(dat_year, desc(Date)) # ~

# 058P
dat_ppd <- select(dat, ProductName, Price, Date)
dat_year2 <- mutate(dat_ppd, Year = lubridate::year(Date))
dat_date_order <- arrange(dat_year2, Price)

dat_date_order <- dat %>%
  select(ProductName, Price, Date) %>%
  mutate(Year = lubridate::year(Date)) %>%
  arrange(Price)
kable(head(dat_date_order))

# 059P
dat_summary <- dat_date_order %>%
  group_by(Year) %>%
  summarise(avg = mean(Price))
kable(dat_summary)

# 060P
sales <- readr::read_csv("sales.csv") %>%
  dplyr::arrange(UserID, SaleDate)
kable(head(sales))

str(sales)

# 061P
dat_join <- sales %>%
  left_join(dat, key = "ProductID")
kable(head(dat_join))

a <- data.frame(
  x1=c("A","B","C") ,
  x2=c(1,2,3)
)
b <- data.frame(
  x1=c("A","B","D") ,
  x3=c(TRUE , FALSE , TRUE)
)
kable(a)

# 062P
kable(b)

inner <- inner_join(a, b, by = "x1")
kable(inner)

left <- left_join(a, b, by = "x1")
kable(left)

right <- right_join(a, b, by = "x1")
kable(right)

# 063P
full <- full_join(a, b, by = "x1")
kable(full)

semi <- semi_join(a, b, by = "x1")
kable(semi)

anti <- anti_join(a, b, by = "x1")
kable(anti)
