## Part 2[H]
## 2.1 RpbP[W̃_E[hLO

# 067P
# CRANɓo^ĂŐVpbP[W擾
paste0(Sys.Date() , "_")

# 068P
nrow(available.packages())

# 069P
# ~Ԃ̃f[^̂͂߂ƏIw
start <- as.Date('2017-06-01')
today <- as.Date('2017-06-01')

all_days <- seq(start, today, by = 'day')

# _E[htURL𐶐
year <- as.POSIXlt(all_days)$year + 1900
urls <- paste0('http://cran-logs.rstudio.com/', year, '/', all_days, '.csv.gz')
# download.filegāAt@C_E[h
download.file(urls, "testdl_cranpackage.tsv")

# ĂȂf[^ꍇAȉsĂ݂ĂB
missing_days <- setdiff(all_days, tools::file_path_sans_ext(dir(), TRUE))

# t@CC|[g
check_file <- read.csv("testdl_cranpackage.tsv")
# 10 120s̃f[^
dim(check_file)

# 070P
# 擪10s̃f[^擾
head(check_file)

# s
formatC(nrow(check_file) * 30 , format="d" , big.mark = ',') 

# t@CTCYiMBj(4MB30)
4 * 30

# 071P
install.packages("dplyr")

library(dplyr)

# 072P
# _E[hԂw
start <- as.Date('2017-05-01')
today <- as.Date('2017-05-31')

all_days <- seq(start, today, by = 'day')

year <- as.POSIXlt(all_days)$year + 1900
urls <- paste0('http://cran-logs.rstudio.com/', year, '/', all_days, '.csv.gz')

# f[^H&܂Ƃ߂
#@(30*20MB炢̂ŎԂ܂)

for(i in 1:length(urls)){
  tmp <- tempfile()
  download.file(urls[[i]], tmp)
  d <- read.csv(gzfile(tmp) , as.is = TRUE)
  d <- d %>% group_by(date  , r_arch , r_os , package  , country) %>% summarise(dlc_cnt = n()) 
  if (i == 1){dd <- d} else {dd <- rbind(dd , d)}
  rm(tmp)
  rm(d)
}

# Wvf[^
glimpse(dd)

# 073P
# pbP[W
nrow(table(dd$package))

# _E[h
formatC(sum(dd$dlc_cnt) , format="d" , big.mark = ',')

install.packages("ggplot2")

library(ggplot2)

# 074P
# ʂɃ_E[hWv
ts_dd <- dd %>% group_by(date) %>% summarise(cnt_dld = sum(dlc_cnt))
# Wvf[^̊mF
glimpse(ts_dd)

# ʖ_Ot
ggplot(ts_dd , aes(as.Date(date) , cnt_dld/10000)) + geom_bar(stat = "identity") + scale_x_date(date_labels = "%b %d")

rank_dd <- dd %>% group_by(package) %>% summarise(dlc_packages = sum(dlc_cnt)) %>% 
  mutate(rank = dense_rank(desc(dlc_packages)) , share = dlc_packages / sum(dd$dlc_cnt)) %>% 
  arrange(rank) %>% 
  select(rank , package , dlc_packages , share)
head(rank_dd , 10)

# 075P
length(table(dd$country))

rank_dd_by_cntry <- dd %>% group_by(country , package) %>% summarise(dlc_packages = sum(dlc_cnt)) %>% 
  mutate(rank = dense_rank(desc(dlc_packages))) %>% 
  arrange(country , rank) %>% 
  select(country , rank , package , dlc_packages)

# 076P
# { TOP10 
rank_dd_by_cntry %>% filter(country == "JP") %>% head(10)

# AJ
rank_dd_by_cntry %>% filter(country == "US") %>% head(10)

# 077P
# j[W[h
rank_dd_by_cntry %>% filter(country == "NZ") %>% head(10)

