## Part 2[H]
## 2.3 @BwK̂߂̃xCYœK

# 090P
# T͈͂̎w
cost_range <- 10 ^ seq(-4, 5, length.out = 10)
gamma_range <- 10 ^ seq(-5, 4, length.out = 10)
# iq̍쐬
grid <- expand.grid(cost = cost_range, gamma = gamma_range)

# iq̕`
library(ggplot2)
ggplot(grid, aes(x = cost, y = gamma)) + geom_point() + 
  scale_x_log10(breaks = 10^c(-2,1,4), labels = parse(text = paste0("10^", c(-2,1,4)))) + 
  scale_y_log10(breaks = 10^c(-3,0,3), labels = parse(text = paste0("10^", c(-3,0,3))))

# 091P
library(e1071)
set.seed(71)

# SVM ɑ΂ObhT[`̎s
tune_result <- tune.svm(Species ~ ., data = iris, scale = TRUE, 
                        gamma = gamma_range, cost = cost_range,
                        tunecontrol = tune.control(sampling = "cross", cross = 10))

# ʂ̕\
ggplot(tune_result$performances, aes(x = cost, y = gamma)) + 
  geom_point(aes(size = 1-error)) + 
  scale_x_log10(breaks = 10^c(-2,1,4), labels = parse(text = paste0("10^", c(-2,1,4)))) + 
  scale_y_log10(breaks = 10^c(-3,0,3), labels = parse(text = paste0("10^", c(-3,0,3)))) +
  guides(size = guide_legend(title = "", reverse = TRUE))

# œKȃnCp[p[^
tune_result$best.parameters

# ̂Ƃ̐
1 - tune_result$best.performance


# 097P
library(e1071) # SVM ̂
library(GPfit) # KEXߒ̂

# Obh̍쐬
cost_range <- 10 ^ seq(-4, 5, length.out = 10)
gamma_range <- 10 ^ seq(-5, 4, length.out = 10)
grid <- expand.grid(cost = cost_range, gamma = gamma_range)
scaled_grid <- scale(log10(grid), c(-4, -5), c(9, 9))

# ړI֐(œK֐)̒`
obj_func <- function(cost, gamma) {
  tune_result <- tune.svm(Species ~ ., data = iris, scale = TRUE, gamma = gamma_range, cost = cost_range,
                tunecontrol = tune.control(sampling = "cross", cross = 10))
  accuracy <- 1 - t$best.performance
  accuracy
}

# l֐̒`(Upper Confidence Bound) 
acq_func <- function(mu, var, k) {
  acqs <- mu + k * sqrt(var)
  which.max(acqs)
}

# l̐ݒ (lłɊϑĂ)
set.seed(2)
inds <- c(1, 10, 91, 100)
ys <- c(0.26, 0.966, 0.226, 0.233)

# ϑ 30 JԂ
for (i in 1:26) {
  # KEXߒɂ]l̕zvZ
  gp <- GP_fit(scaled_grid[inds, ], ys, corr = list(type = "exponential", power = 2))
  pred <- predict.GP(gp, scaled_grid)
  
  # l֐ɂ莟̊ϑ_vZ
  next_ind <- acq_func(pred$Y_hat, pred$MSE, k = 3)
  next_y <- do.call(obj_func, args = as.list(grid[next_ind,]))
  
  # ʂ̍XV
  inds <- c(inds, next_ind)
  ys <- c(ys, next_y)
}

# œK_ƕ]l̕\
grid[inds[which.max(ys)], ]

max(ys)
