## Part 2[H]
## 2.4 K}z̍Ŗސɂ

## 103P
# fBK}֐̋t֐ igamma() g
library(distr)

### K}֐̃p[^Ŗސ肷֐ ###
estimate_gamma <- function(values, method = c("FOApprox", "LocalApprox")) {
  method <- match.arg(method)

  # Œl炩ߌvZĂ
  mean_values <- mean(values)
  mean_log_values <- mean(log(values))
  log_mean_values <- log(mean_values)

  # ΐޓxvZ֐
  compute_loglik <- function(values, a, b) {
    sum(dgamma(values, a, b, log = TRUE))
  }
  
  # p[^̏lݒ
  a <- 0.5 / (log_mean_values - mean_log_values)
  b <- mean_values / a
  # ΐޓx̏lvZ
  log_lik_old <- compute_loglik(values, a, b)
  
  # ΐޓx̕ωi[ϐ
  epsilon <- Inf 
  # ΐޓx̕ωȂ܂Ńp[^XV
  while (epsilon > 1e-5) {
    if (method == "FOApprox") {
      # ꎟߎő剻@ɂp[^ a XV
      a <- igamma(mean_log_values - log_mean_values + log(a))
    } else {
      # Ǐߎő剻@ɂp[^ a XV
      numerator <- mean_log_values - digamma(a) - log_mean_values + log(a)
      denominator <- a^2 * (1/a - trigamma(a))
      inv_a <- 1/a + numerator/denominator
      a <- 1 / inv_a
    }
    # p[^ b XV
    b <- mean_values / a
    
    # ΐޓxvZ
    log_lik <- compute_loglik(values, a, b)
    # ΐޓx̕ωvZ
    epsilon <- abs(log_lik - log_lik_old)
    # ݂̑ΐޓxۊ
    log_lik_old <- log_lik
  }
  c(a = a, b = b)
}

# 105P
set.seed(314)
# K}z (a=3, b=2) TvO
values <- rgamma(n = 500, shape = 3, scale = 2)

# ꎟߎő剻@ɂ鐄
estimate_gamma(values, method = "FOApprox")


# Ǐߎő剻@ɂ鐄
estimate_gamma(values, method = "LocalApprox")


library(microbenchmark)

microbenchmark(
  FOApp = estimate_gamma(values, method = "FOApprox"),
  Local = estimate_gamma(values, method = "LocalApprox")
)
