## Part 2[H]
## 2.8 nf[^RŉFRvX}

# 144P
file<-"h22ka01101.shp"

# f[^̏
pj<-CRS("+proj=longlat +datum=WGS84") # ܓxoxȂ̂+projlonglatw
Chuo<- maptools::readShapePoly(file,proj4string = pj) # SpatialPolygonDataframeƂēǂݍ

# f[^̉10R[h\
Chuo@data %>% tail(.) %>% kable()

# 145P
# |S1ڂ\
Chuo@polygons[1]

# 146P
# lng,latɑ\_i[
Chuo.d<- data.frame(MOJI=Chuo@data$MOJI,
                    X_CODE=Chuo@data$X_CODE,
                    Y_CODE=Chuo@data$Y_CODE,
                    KEY_CODE=Chuo@data$KEY_CODE,
                    JINKO=Chuo@data$JINKO,
                    SETAI=Chuo@data$SETAI)
Chuo@data <- Chuo.d
Chuo@data %>% tail(.) %>% kable(.,format="markdown")


# 148P
# tHgt@~[̎w
# CI"MEI"ƂfamilyƂĒ`
windowsFonts(MEI=windowsFont("Meiryo"))

# Polygon̏data.frameɕϊ
map_df<-ggplot2::fortify(Chuo)

map_df %>% head(.,10) %>% knitr::kable(.,format="markdown")


# PolygonData̕RÂ
map_join<-data.frame(id=as.numeric(row.names(Chuo@data))-1,Chuo@data)
map_join$id<-as.character(map_join$id)

map_df<- dplyr::left_join(map_df,map_join,by="id") # JOIN
map_df %>% head(.,10) %>% knitr::kable(.,format="markdown")

# 149P
# Al
ggplot(map_df,aes(x=long,y=lat,group=group,fill=JINKO))+
  geom_polygon()+
  scale_fill_continuous(low="# fee0d2",high = "Red")+
  ggtitle("Dys揬nʐl")+
  theme(plot.title=element_text(size = rel(2),family = "MEI"))+
  coord_map("polyconic")

# 150P
# @ɂ8̃NXɗU,Ԋu@
colcode<- map_df$JINKO %>%
  classIntervals(.,n=8,style="equal") %>% findCols(.)

# UNXێ
colname<-map_df$JINKO %>% classIntervals(.,n=8,style="equal")

# NXlf[^Ɋi[
map_df$class<-colcode %>% as.factor(.)

# }p̃x쐬
classlabel<-data.frame(row.names = 1:8,label=1:8)
for(i in 1:8){
  classlabel[i,1]<-paste(round(colname$brks[i],0),round(colname$brks[i+1],0),sep="-")
}


# `
ggplot(map_df,aes(x=long,y=lat,group=group,fill=class))+
  geom_polygon()+
  scale_fill_manual(values = brewer.pal(8,"Reds"),
                    name="l(l)",
                    label=classlabel$label)+
  guides(fill = guide_legend(reverse = TRUE))+
  ggtitle("Dys揬nʐl")+
  theme(plot.title=element_text(size = rel(2),family = "MEI"))+
  coord_map("polyconic")

# 151P
# J[pbg̐(Al)
pal <- colorNumeric(
  palette = "Reds",
  domain = Chuo@data$JINKO
)

# RvX}`ver
leaflet::leaflet(Chuo) %>%
  addProviderTiles(provider = "OpenStreetMap.BlackAndWhite") %>%
  addPolygons(stroke = FALSE,
              fillOpacity = 0.9,
              color = ~pal(Chuo.d$JINKO)) %>%
  addLegend(position='bottomright', pal=pal, values=~JINKO,title="l(l)")


# 152P
# J[pbg̐(UlA@)
pal_q<-leaflet::colorQuantile(
  palette = "Reds",
  domain = Chuo@data$JINKO,
  n=8
)

leaflet::leaflet(Chuo) %>%
  addProviderTiles(provider = "OpenStreetMap.BlackAndWhite") %>%
  addPolygons(stroke = FALSE,
              fillOpacity = 0.9,
              color = ~pal_q(Chuo.d$JINKO)) %>%
  addLegend(position='bottomright', pal=pal_q, values=~JINKO,title="l(%)",labels=~classlabel$label)

# 153P
# Al̃J[pbg𐶐
pal_sp<-smoothPalette(as.numeric(Chuo@data$JINKO),pal="Reds")

# `
plot(Chuo,col=pal_sp)
legend("bottomright",legend=c(max(Chuo@data$JINKO),min(Chuo@data$JINKO)),
       fill = c(min(pal_sp),max(pal_sp)))

# 154P
# k-means@ŗUJ[pbg쐬
colcode_km<- Chuo@data$JINKO %>%
  classIntervals(.,n=8,style="kmeans") %>% findColours(.,pal=brewer.pal(8,"Reds"))

# UNXێ
class_km<-Chuo@data$JINKO %>% classIntervals(.,n=8,style="kmeans")

plot(Chuo,col=colcode_km)
legend("bottomright",legend=str_sub(gsub(",","`",names(attr(colcode_km,"table"))),start = 2,end = -2),
       fill = attr(colcode_km,"palette"))

# 155P
# regionǉ
map_dfc <- map_df %>%
  mutate(region=as.character(id))
kable(head(map_dfc,5),format="markdown")

# R6NX
ChuoChoro <- R6Class(
  "ChuoChoropleth",
  inherit = choroplethr:::Choropleth,
  public = list(
    initialize = function(user.df)
    {
      super$initialize(map_dfc, user.df)
    }
  )
)

# \f[^𐮌`
Chuo.dc<- data.frame(district=map_join$MOJI,
             region=as.character(map_join$id),
             value=as.numeric(map_join$JINKO))
kable(head(Chuo.dc,5),format="markdown")


# 156P
# `̂߂̊֐쐬
SappoRo_choropleth<-function (df, title = "", legend = "", num_colors = 8, zoom = NULL)
{
    c = ChuoChoro$new(df)
    c$title = title
    c$legend = legend
    c$set_num_colors(num_colors)
    c$set_zoom(zoom)
    c$render()
}

# Alŕ`inum_colors1w)
p<-SappoRo_choropleth(Chuo.dc,title="Dysl",legend="",num_colors = 1)
p+scale_fill_continuous(low="# fff5f0",high = "Red")

# 157P
# Ul(num_colors8w)
p2<-SappoRo_choropleth(Chuo.dc,title="Dysl",legend="",num_colors = 8)
p2+scale_fill_brewer(palette = "Reds")
