## Part 2[H]
## 2.9 uVĒTAf[^͂ɒށv"Rƒn}ƘAg"Ă݂


# 160P
# gppbP[W
install.packages("estatapi") # {vf[^擾p
install.packages("dplyr")    # f[^Hp
install.packages("tidyr")    # f[^Hp
install.packages("ggmap")    # ZEܓxoxΉp
install.packages("leaflet")  # vbgp

# _E[hpbP[W̓ǂݍ
library(estatapi)
library(dplyr)
library(tidyr)
library(ggmap) # ZEܓxoxΉp
library(leaflet) # vbgp


# 161P
pbP[W̓ǂݍ
library(estatapi)

# APIgp̂߂ID
AppID <- "擾ID"

# u22Nṽf[^ɉ̂𒲂ׂ
ResultData <- estat_getStatsList(appId = AppID, searchWord = "22N")
PrefData %>% str()

ResultData %>% as.data.frame() %>% head() # 6s

# 162P
# ID0003038591̒ʂp
# ^擾
MetaInfo <- estat_getMetaInfo(appId = AppID, statsDataId = "0003038591")

# f[^̎擾
PrefData <- estat_getStatsData(appId = AppID,
                               statsDataId = "0003038591",
                               cdCat01 = "00710",
                               cdCat02 = "000",
                               cdCat04 = "000",
                               cdCat05 = "000",
                               lvArea = 2)
# g`FbN
PrefData %>% str()

# 163P
PrefData %>% as.data.frame() %>% head()

# 164P
# Nw
ages <- PrefData$cat03_info %>% unique()
ages

# 2. f[^̉H
library(dplyr)
library(tidyr)

# `
Prefdf <- PrefData %>%
  # pPrefDatâAarea_infois{jAcat03_infoiNwjAvalueilj
  select("ni2010j", "N3", value) %>%
  # sɓs{AɔNw悤ɉH
  tidyr::spread(key ="N3", value = value, fill=NA, convert=FALSE, drop=TRUE) %>%
  # uarea_infovus{vɖ̕ύX
  rename(s{ = "ni2010j") %>%
  # ̕ԏԂ𒲐
  select(s{, one_of(ages)) %>%
  # ₷悤data.frame^ɕύX
  as.data.frame()

# ̂悤ȃf[^ɂȂ܂
Prefdf %>% str()

# 165P
Prefdf %>% head()


# 166P
library(ggmap)

# es{̈ܓxoxɓBAPIɒ
PrefInfo <- geocode(Prefdf$s{, source = "google", output = "latlon")

# lanoxAlatܓx
PrefInfo %>% head()

# lf[^ƍ
PrefMap <- Prefdf %>% cbind(PrefInfo)
PrefMap %>% head()

# 167P
# PrefMap̗񖼂ύXĂ
colnames(PrefMap) <- c("s{", "", ages[-1], "lon", "lat")

# l̑`
leaflet(PrefMap) %>%
    addTiles() %>%
    # SAY[TCY𒲐
    setView(lng = 139, lat = 37, zoom = 5) %>%
    # l̑ƂɃvbgTCYς
    addCircles(lng = ~lon, lat = ~lat, weight = 1,
               radius = ~sqrt() * 30,
               # vbgNbNs{Ɛl̐\悤ɂ
               popup = ~paste(s{, , sep=": "))

# 168P
# es{ɂAeNw߂銄vZĂ݂
tmp <- PrefMap %>%
  select(one_of(ages[-1])) / PrefMap$ * 100
# 񖼂̕ύX
colnames(tmp) <- paste(ages[-1], "(%)")
# ̃f[^ƌ
PrefMap2 <- cbind(PrefMap, tmp)

# vbgFł60?64
leaflet(PrefMap2) %>%
  addTiles() %>%
  # SAY[TCY𒲐
  setView(lng = 139, lat = 37, zoom = 5) %>%
  # l̑ƂɃvbgTCYς
  addCircles(lng = ~lon, lat = ~lat, weight = 1,
             radius = ~sqrt(`60`64 (%)`) * 10000,
             # vbgNbNs{Ɛl̐\悤ɂ
             popup = ~paste(s{, paste(round(`60`64 (%)`, digits = 2), "%", sep=""), sep=": "))


# 169P
PrefMap3 <- PrefMap2 %>%
  select(s{, lon, lat, `0`4 (%)`, `5`9 (%)`, `10`14 (%)`, `15`19 (%)`,
             `20`24 (%)`, `25`29 (%)`, `30`34 (%)`, `35`39 (%)`, `40`44 (%)`,
             `45`49 (%)`, `50`54 (%)`, `55`59 (%)`, `60`64 (%)`, `65`69 (%)`,
             `70`74 (%)`, `75`79 (%)`, `80`84 (%)`, `85`89 (%)`, `90`94 (%)`,
             `95`99 (%)`, `100Έȏ (%)`, `s (%)`)

write.csv(PrefMap3, "PrefMap.csv", row.names = F)

# 169P
library(shiny)

# f[^ǂݍ
PrefMap <- read.csv("PrefMap.csv", header = T, stringsAsFactors = F)

# Nw̃xNgpӂĂ
ages <- c("age0_4(%)", "age5_9(%)", "age10_14(%)", "age15_19(%)", "age20_24(%)", "age25_29(%)",
          "age30_34(%)", "age35_39(%)", "age40_44(%)", "age45_49(%)", "age50_54(%)", "age55_59(%)",
          "age60_64(%)", "age65_69(%)", "age70_74(%)", "age75_79(%)", "age80_84(%)", "age85_89(%)",
          "age90_94(%)", "age95_99(%)", "over100(%)", "unknown(%)")

# 񖼒
colnames(PrefMap) <- c("s{", "lon", "lat", ages)

# v_Ep
ages_choice <- ages
names(ages_choice) <- ages_choice

# 170P
library(shiny)
library(ggplot2)
library(leaflet)

ui <- bootstrapPage(
  tags$style(type = "text/css", "html, body {width:100%;height:100%}"),
  leafletOutput("mymap", width = "100%", height = "100%"), # n}

  absolutePanel(bottom = 30, right = 20,
                h3("eNwes{̐lɐ߂銄"),
                selectInput("age", "NwI", choices = ages_choice, width = 600),
                plotOutput("graph", width = 600) # v_EƃOt
  )
)

# 170P
library(shiny)
library(leaflet)
library(dplyr)
library(ggplot2)

server <- function(input, output) {
  # Nw̑I
  selectAge <- reactive({
    df <- data.frame("s{" = PrefMap$s{,
                     "lon" = PrefMap$lon,
                     "lat" = PrefMap$lat,
                     "age" = PrefMap[, input$age])
  })

  # n}
  output$mymap <- renderLeaflet({
    leaflet(selectAge()) %>%
      addTiles() %>%
      # SAY[TCY𒲐
      setView(lng = 142, lat = 38, zoom = 6) %>%
      # l̑ƂɃvbgTCYς
      addCircles(lng = ~lon, lat = ~lat, weight = 1,
                 radius = ~sqrt(age) * 10000,
                 # vbgNbNs{Ɛl̐\悤ɂ
                 popup = ~paste(s{, paste(round(age, digits = 2), "%", sep=""), sep=": "))
  })

  # Ot
  output$graph <- renderPlot({
    g <- ggplot(selectAge(), aes (x = s{, y = age)) +
      geom_bar(width = 0.8, stat = "identity", fill="steelblue") +
      theme_bw(base_family = "HiraKakuProN-W3") +
      ylab("age(%)") +
      theme(axis.text.x = element_text(angle = 90, hjust = 1))
    plot(g)
  })
}

# 171P
install.packages('rsconnect')
library(rsconnect)
rsconnect::setAccountInfo(name   = "YOUR NAME",
                          token  = "YOUR TOKEN",
                          secret = "YOUR SECRET")
deployApp()
