## Part 2[H]
## 2.7 KOl̔éu́vs

# 134P
# CRAÑCXg[
install.packages("tidytext")
install.packages("sentimentr")

library(tidytext) # f[^̐`EWv
library(sentimentr) # 

# 135P
library(magrittr) # pCvZq̗L
library(knitr) # HTMLt@Cւ̕\f[^o
library(feather) # t@Cǂݍ
library(tidyr) # f[^`
library(dplyr) # f[^S
library(lubridate) # tf[^̏
library(ggplot2) # 摜`
library(viridis) # 摜̑

### Oƃf[^̓ǂݍ


# Apache Project̂Pɒ[𔭂ĊJꂽ
# RPythonƂf[^͊ŗp\
# ݊̂f[^`̃t@Cǂݍ
df.inbs <- read_feather("inbounds_1604.feather")

# P
df.inbs %<>% 
  mutate(text_n = row_number())

# 136P
glimpse(df.inbs)

tokenizers::tokenize_words("Hello, I'm Shinya.")

# 137P
# eP؂ɂAقȂ̃f[^ƂĈ悤ɂ
df.tidy <- df.inbs %>%
  unnest_tokens(output = word, input = trimed_text, token = "words", drop = FALSE)


# Xgbv[h̃f[^̈ꕔ݂Ă݂
data("stop_words", package = "tidytext")
stop_words %>% head(5) %>% kable(format = "markdown")

# 138P
# g[Nʂۑf[^t[Xgbv[hƂȂPO
df.tidy %<>% 
  anti_join(stop_words, by = "word") # anti_join()ɂAword񂪈vȂf[^̂݌

data("sentiments", package = "tidytext")
# bing̎f[^𒊏o
df.sent.dic <- sentiments %>%
  filter(lexicon == "bing") %>%
  select(-score)

# 139P
df.tidy %>%
  inner_join(df.sent.dic, by = "word") %>% # wordɂ
  count(word, sentiment, sort = TRUE) %>% # PƊ̐ɉĕpxWv
  ungroup() %>% 
  filter(n > 40) %>% # o񐔂40ȏ̒P𒊏o
  mutate(n = if_else(sentiment == "negative", -n, n), # ̊P̏ꍇAl}CiXɂ
         word = reorder(word, n)) %>%  # px̑Pꏇɕёւw肷
  ggplot(aes(word, n, fill = sentiment)) +
  geom_bar(stat = "identity") +
  ylab("word count") + 
  scale_fill_manual(values = c("#FB3F1C", "#7ABA3A")) +
  theme(axis.text.x = element_text(angle = 90, hjust = 1))


# 140P
df.inbs$trimed_text[25]

df.inbs$trimed_text[25] %>% sentiment() # sIhɂꕶ̋؂肩XRAO{

df.inbs$trimed_text[25] %>% sentiment_by() # e1̕ƂăXRAO

df.sent.score <- df.inbs$trimed_text %>% 
  sentiment_by() %>% 
  select(text_n = element_id, sentiment = ave_sentiment)

# 141P
df.inbs %>%
  inner_join(df.sent.score, by = "text_n") %>%
  filter(sentiment != 0) %>%
  dplyr::mutate(
  week = floor_date(tweeted_at, "day") %>% week(),
  wday = wday(tweeted_at, label = TRUE)
  ) %>%
  group_by(week, wday) %>%
  summarise(n = n(),
  mean = mean(sentiment)) %>%
  ggplot(aes(wday, week, size = n)) +
  geom_point(aes(fill = mean), shape = 21) +
  scale_fill_viridis(option = "D") +
  theme_bw() +
  scale_size("n") +
  scale_y_reverse(lim = c(18, 14), labels = c("0401-0407", "0408-0414", "0415-0421", "0422-0428", "0429-0431")) +
  theme(axis.text.x = element_text(angle = 60, hjust = 1))

